diff a/src/hotspot/share/opto/runtime.cpp b/src/hotspot/share/opto/runtime.cpp
--- a/src/hotspot/share/opto/runtime.cpp
+++ b/src/hotspot/share/opto/runtime.cpp
@@ -348,11 +348,11 @@
 
   oop result = current->vm_result();
   if ((len > 0) && (result != nullptr) &&
       is_deoptimized_caller_frame(current)) {
     // Zero array here if the caller is deoptimized.
-    const size_t size = TypeArrayKlass::cast(array_type)->oop_size(result);
+    const size_t size = TypeArrayKlass::cast(array_type)->oop_size(result, result->mark());
     BasicType elem_type = TypeArrayKlass::cast(array_type)->element_type();
     size_t hs_bytes = arrayOopDesc::base_offset_in_bytes(elem_type);
     assert(is_aligned(hs_bytes, BytesPerInt), "must be 4 byte aligned");
     HeapWord* obj = cast_from_oop<HeapWord*>(result);
     if (!is_aligned(hs_bytes, BytesPerLong)) {
